# typed: strict
# frozen_string_literal: true

require 'sorbet-runtime'

# Blackrug is this groundbreaking parser that allows you to sweep markdown under
# the rug by wrapping it by <!---Blackrug--->
# Typical markdown parser will render the blackrugged elements.
# You need to pre-parse it via Blackrug
module Blackrug
  class << self
    extend T::Sig

    sig { params(text: String).returns(String) }
    def sweep(text)
      text.split(/(?<!`)<!---Blackrug--->(?!`)/).select.with_index { |_, i| i.even? }.join
    end

    alias_method(:🧹, :sweep)
  end
end
